global gOL

property pHisto
property pImg

on beginSprite me
  
  data = [:]
  sendAllSprites(#getFormData, data)
  tChannel = data["channel"]
  
  me.channelChanged(tChannel)
end

on mouseWithin me
  x = _mouse.mouseH - sprite(me.spriteNum).left
  member("index").text = "Index: " & x
  member("pixels").text = "Pixels: " & pHisto[x+1]
end

on channelChanged me, tChannel
  pHisto = _movie.stage.movie.mGetHistogram(integer(tChannel))
  
  pImg = sprite(me.spriteNum).member.image
  pImg.fill(pImg.rect, RGB(255,255,255))
  h = pImg.height+1 -- 150
  f = float(h) / max(pHisto)  
  repeat with x = 0 to 255
    pImg.draw(x,h,x,h-pHisto[x+1]*f ,RGB(0,0,0))
  end repeat
  
  sprite("colorBar").member = member("colorBar_"&tChannel)
end