global gOL

property pPalette
property pIndex

on beginSprite me
    
  pPalette = gOL["palette"].duplicate() 
  pIndex = 1
  
  --mSetColors()
  
  img = member("pal").image
  cnt = count(pPalette)
  repeat with y=0 to 15
    repeat with x=0 to 15
      n = y*16 + x + 1
      if n<=cnt then
        col = pPalette[n]
        img.fill(rect(x*20,y*20,x*20+17,y*20+17), col)
      else
        --img.fill(rect(x*20,y*20,x*20+17,y*20+17), RGB(0,0,0))
      end if
    end repeat
  end repeat
    
  if count(pPalette) then
    col = pPalette[1]
    member("index").text = "Index: 0"
    member("red").text = string(col.red)
    member("green").text = string(col.green)
    member("blue").text = string(col.blue)
  end if
  
end

on mouseDown me
  p = _mouse.mouseLoc
  x = p[1]/20
  y = p[2]/20
  n = y*16 + x + 1
  
  if n<=pPalette.count then
    
    sprite("marker").loc = sprite(me.spriteNum).loc + point(x*20-2, y*20-2)
    
    col = pPalette[n]
    member("index").text = "Index: " & (n-1)
    member("red").text = string(col.red)
    member("green").text = string(col.green)
    member("blue").text = string(col.blue)
        
    pIndex = n
  end if
end

on mSetColor me
  col = RGB(integer(member("red").text), integer(member("green").text), integer(member("blue").text))
  pPalette[pIndex] = col
  
  y = (pIndex-1) / 16
  x = (pIndex-1) mod 16
  
  sprite(me.spriteNum).member.image.fill(rect(x*20,y*20,x*20+17,y*20+17), col)
end
