property pData

----------------------------------------
--
----------------------------------------
on mInit me  
  pData = [:]
end

----------------------------------------
--
----------------------------------------
on mDestroy me  
  --
end

----------------------------------------
--
----------------------------------------
on mShow (me)
  s = ""
  cnt = count(pData)
  repeat with i = 1 to cnt
    
    put "menu: "&pData.getPropAt(i)&RETURN after s
    m = pData[i]
    repeat with tItem in m
      if tItem["name"]="-" then
        put "(-|"&RETURN after s
      else
        if tItem["enabled"]=0 then put "(" after s
        if tItem["checkMark"]=1 then put "! " after s
        put tItem["name"] after s
        if string(tItem["letter"])<>"" then put "/"&tItem["letter"] after s
        put "|"&tItem["handler"]&RETURN after s
      end if
    end repeat
  end repeat
  
  member("~menu").text = s
  installMenu member "~menu"
end

----------------------------------------
--
----------------------------------------
on mHide (me)
	installMenu 0
end

----------------------------------------
--
----------------------------------------
on mAddMenu (me, tMenuName)
  me.pData.addProp(tMenuName, [])
end

----------------------------------------
--
----------------------------------------
on mAddItem (me, tMenuName, tItem, tUpdateFlag)
  if voidP(tItem["enabled"]) then tItem["enabled"]=1
  if voidP(tItem["checkMark"]) then tItem["checkMark"]=0
  me.pData[tMenuName].add(tItem)
  if tUpdateFlag then me.update()
end

----------------------------------------
--
----------------------------------------
on mAddSep (me, tMenuName)
  me.mAddItem (tMenuName, ["name": "-"])
end

----------------------------------------
--
----------------------------------------
on mSetItemEnabledEnabled (me, tMenu, tItemName, flag)
  cnt = pData[tMenu].count
  repeat with i = 1 to cnt
    if pData[tMenu][i]["name"]=tItemName then
      pData[tMenu][i]["enabled"]=flag
      exit repeat
    end if
  end repeat
  
  set the enabled of menuItem tItemName of menu tMenu to flag
end

----------------------------------------
--
----------------------------------------
on mSetItemCheckMark (me, tMenu, tItemName, flag)
  cnt = pData[tMenu].count
  repeat with i = 1 to cnt
    if pData[tMenu][i]["name"]=tItemName then
      pData[tMenu][i]["checkMark"]=flag
      exit repeat
    end if
  end repeat
  
  set the checkMark of menuItem tItemName of menu tMenu to flag
end

