property pButtonList

--property pS
property pM


-- images
property pImg

--property pSepImg
property pBgImg
property pRoImg
property pDoImg

property pSensitive
property pRoButtonPos
property pDoButtonPos

-- tooltip
--property pMouseLoc
--property pMouseTicks
--property pTicks
--property pTooltip


----------------------------------------
-- 
----------------------------------------
--on new me, tSprite --tWidth
--  
--  --pBgImg = member("toolbar_bg", "toolbar").image.duplicate()
--  --updateStage
--  
--  w = _movie.stage.rect.width
--  h = 30
--  
--  pBgImg = image(w, h, 24)
--  pBgImg.fill(pBgImg.rect, RGB("#D4D0C8"))
--  pBgImg.draw(point(2, 0), point(w-3, 0), RGB("#808080"))
--  pBgImg.draw(point(2, 1), point(w-3, 1), RGB("#FFFFFF"))
--  pBgImg.draw(point(2, h-2), point(w-3, h-2), RGB("#808080"))
--  pBgImg.draw(point(2, h-1), point(w-3, h-1), RGB("#FFFFFF"))
--  
--  pImg = pBgImg.duplicate()
--  
--  --pSepImg = member("separator", "toolbar").image
--  pSepImg = image(2,22,24)
--  pSepImg.draw(point(0, 0), point(0, 22), RGB("#808080"))
--  pSepImg.draw(point(1, 0), point(1, 22), RGB("#FFFFFF"))
--  
--  pRoImg = member("button_ro", "toolbar").image
--  pDoImg = member("button_do", "toolbar").image
--  
--  pSensitive = []
--  pRoButtonPos = 0
--  
--  pS = tSprite
--  
--  pButtonList = []
--  return me
--end

----------------------------------------
--
----------------------------------------
on mInit (me, inputImg, tbButtonFlags, tbCallbacks) -- tbTooltips
    
  pRoImg = member("button_ro", "gui").image
  pDoImg = member("button_do", "gui").image
  
  inputAlpha = inputImg.extractAlpha()
  inputImg.setAlpha(255)
  inputImg.useAlpha=0
  
  w = 640 -- 19*23
  pImg = image(w, 24, 24)
  pImg.fill(pImg.rect, RGB("#D4D0C8"))
  
  r = rect(0,0,16,16)
  
  -- seperator
  sepImg = image(2, 20, 24)
  sepImg.fill(rect(0,0,1,20), RGB(128,128,128))
  sepImg.fill(rect(1,0,2,20), RGB(255,255,255))
  sr = sepImg.rect
  
  pSensitive = []
  pButtonList = []
  
  i = 0
  x = 0
  cnt = tbButtonFlags.count
  repeat with j = 1 to cnt
    f = tbButtonFlags[j]
    if f="|" then
      x = x + 3
      pImg.copyPixels(sepImg, sepImg.rect.offset(x,1), sr)
      x = x + 2 + 3
    else 
      if f="1" then
        x = x + 3
        
        pImg.copyPixels(inputImg, r.offset(x,3), r.offset(i*16,0), [#maskImage: inputAlpha])
        
        tButtonImg = image(16,16,24)
        tButtonImg.fill(tButtonImg.rect, RGB(255,255,255))
        tButtonImg.copyPixels(inputImg, tButtonImg.rect, r.offset(i*16,0), [#maskImage: inputAlpha ])
        
        tCallback = tbCallbacks[j]
        pButtonList.add([tButtonImg, tCallback]) --, tTooltip])
        pSensitive.add( [x, x+23] )
        
        x = x + 16 + 4
      end if
      i = i+1
    end if
  end repeat
  
  pImg.setAlpha(255)
  pImg.useAlpha=0
  
  pM = member("toolbar")
  pM.image = pImg
  pM.regpoint = point(0,0)

end

----------------------------------------
--on endSprite me
----------------------------------------
on mDestroy me
  -- tooltip
  sendAllSprites (#DisplayText_SetText)
  
  pM.image = image(1,1,24)
end

----------------------------------------
-- 
----------------------------------------
--on mAddButton me, tButtonImg, tCallback, tTooltip
--  pButtonList.add([tButtonImg, tCallback, tTooltip])
--end

----------------------------------------
-- 
----------------------------------------
on mFindButton (me, p)
  x = p[1]
  y = p[2]  
  if (y>2 AND y<26) then 
    cnt = pSensitive.count
    repeat with i = 1 to cnt
      sec = pSensitive[i]
      if voidP(sec) then next repeat
      if x>=sec[1] AND x<=sec[2] then return i
      if sec[1]>x then exit repeat
    end repeat
  end if
  return 0
end

----------------------------------------
-- 
----------------------------------------
on mReset me
  pM.image = me.pImg
  pM.regpoint=point(0,0)
  
  updateStage() -- ???
  
  --pS.loc = point(0,0)
  --pS.rect=rect(0,0,420,30)
  
  me.pRoButtonPos = 0
  me.pDoButtonPos = 0 -- ???
end


----------------------------------------
-- 
----------------------------------------
on mouseWithin me
  -- if _mouse.mouseDown then return
  
  m = the mouseLoc
  
  -- tooltip
  --  if m <> pMouseLoc then
  --    pMouseLoc = m
  --    pMouseTicks = the ticks
  --  end if
  
  n = me.mFindButton(m)
  
  --  if n>0 then     
  --    pTicks = 30
  --    if the ticks-pMouseTicks>=pTicks then 
  --      
  --      --      txt = pButtonList[n][3]
  --      --      if txt<>pTooltip then
  --      --        sendAllSprites (#DisplayText_SetText, txt, point(pSensitive[n][1]+11, 29), #topCenter)
  --      --        pTooltip = txt
  --      --      end if
  --      
  --      
  --    else
  --      
  --      --      pTooltip = ""
  --      --      sendAllSprites (#DisplayText_SetText)
  --      
  --    end if
  --  end if
  
  if _mouse.mouseDown then
    if me.pDoButtonPos>0 and n<>me.pDoButtonPos then
      me.mReset()
    end if
  else
    if n<>me.pRoButtonPos then
      if n>0 then
        sec = me.pSensitive[n]
        tmpImg = me.pImg.duplicate()
        tmpImg.copyPixels(me.pRoImg, me.pRoImg.rect.offset(sec[1]-3, 0), me.pRoImg.rect, [#ink:36, #bgColor:rgb("#FF00FF")] )
        
        pM.image = tmpImg
        pM.regPoint = point(0,0)
        
      else
        me.mReset()
      end if
      me.pRoButtonPos = n
    end if
  end if
end

----------------------------------------
-- 
----------------------------------------
on mouseDown me
  n = me.mFindButton(the mouseLoc)
  if n then
    sec = me.pSensitive[n]
    tmpImg = me.pImg.duplicate()
    tmpImg.copyPixels(me.pDoImg, me.pDoImg.rect.offset(sec[1]-3, 0), me.pDoImg.rect, [#ink:36, #bgColor:rgb("#FF00FF")] )
    
    buttonImg = me.pButtonList[n][1]
    tmpImg.copyPixels(buttonImg, buttonImg.rect.offset(sec[1]+1,5), buttonImg.rect)--, [#ink:36, #bgColor:rgb("#FF00FF")])
    
    pM.image = tmpImg
    pM.regPoint = point(0,0)
  end if
  me.pDoButtonPos = n
end

----------------------------------------
-- 
----------------------------------------
on mouseUp me
  if me.pDoButtonPos then
    
    tAction = pButtonList[me.pDoButtonPos][2]
   	--put pButtonList[me.pDoButtonPos]
    me.mReset() -- ???
    
       if listP(tAction) then
    --      --call (#handlerName, script, {args...}
          call(tAction[1],tAction[2], me, me.pDoButtonPos)
        else
          --sendAllSprites(tAction, me, me.pDoButtonPos)
          sendSprite(0, tAction, me, me.pDoButtonPos)
       end if
  end if
end

----------------------------------------
-- 
----------------------------------------
--on mouseUpOutside me
on mouseLeave me
  if me.pRoButtonPos>0 then
    me.mReset()
  end if
  --me.mouseUp()
end

--on mouseUpOutside me
--	me.mouseUp()
--end








----------------------------------------
-- 
----------------------------------------
--on mSetButton me, pos, tButtonImg, tCallback, tTooltip
--  --pBgImg = member("toolbar_bg", "toolbar").image.duplicate()
--  pImg = pBgImg.duplicate()
--  pButtonList[pos] = [tButtonImg, tCallback, tTooltip]
--  me.show()
--end

----------------------------------------
-- 
----------------------------------------
--on mAddSeperator me
--  pButtonList.add(VOID)
--end

----------------------------------------
-- 
----------------------------------------
--on mShow me
--  tLeft = 3
--  repeat with tButton in pButtonList
--    if voidP(tButton) then
--      pSensitive.add(VOID)
--      pImg.copyPixels(pSepImg, pSepImg.rect.offset(tLeft+1,4), pSepImg.rect, [#ink:36, #bgColor:rgb("#FF00FF")])
--      tLeft = tLeft  + 5
--    else
--      pSensitive.add( [tLeft, tLeft+22] )
--      pImg.copyPixels(tButton[1], tButton[1].rect.offset(tLeft+1,4), tButton[1].rect, [#ink:36, #bgColor:rgb("#FF00FF")])
--      tLeft = tLeft  + 25
--    end if
--  end repeat
--  
--  pM.image = pImg
--  pM.regpoint=point(0,0)
--  
--  --pS.loc = point(0,0)
--  --pS.rect=rect(0,0,420,30)
--  
--  updateStage
--end

----------------------------------------
-- 
----------------------------------------
--on XmouseWithin me
--  m = the mouseLoc
--  
--  -- tooltip
--  if m <> pMouseLoc then
--    pMouseLoc = m
--    pMouseTicks = the ticks
--  end if
--  
--  n = me.findButton(m)
--  
--  if n>0 then     
--    pTicks = 30
--    if the ticks-pMouseTicks>=pTicks then 
--      --sendAllSprites(#showToolTip, pTooltipText) --, point(sprite(me.spriteNum).right+10, the mouseV) )
--      txt = pButtonList[n][3]
--      if txt<>pTooltip then
--        sendAllSprites (#DisplayText_SetText, txt, point(pSensitive[n][1]+11, 29), #topCenter)
--        pTooltip = txt
--      end if
--      
--      --point(14, 29) #topCenter
--    else
--      pTooltip = ""
--      sendAllSprites (#DisplayText_SetText)
--      --sendAllSprites(#hideToolTip)
--    end if
--  end if
--  
--  if n<>pRoButtonPos then
--    if n>0 then
--      sec = pSensitive[n]
--      tmpImg = pImg.duplicate()
--      tmpImg.copyPixels(pRoImg, pRoImg.rect.offset(sec[1], 4), pRoImg.rect, [#ink:36, #bgColor:rgb("#FF00FF")] )
--      pS.member.image = tmpImg
--      
--      
--    else
--      me.reset()
--    end if
--    pRoButtonPos = n
--  end if
--  
--end

----------------------------------------
-- 
----------------------------------------
--on XmouseLeave me
--  if pRoButtonPos then me.reset()
--  
--  sendAllSprites (#DisplayText_SetText)
--end

----------------------------------------
-- 
----------------------------------------
--on XmouseDown me
--  n = me.findButton(the mouseLoc)
--  if n then
--    sec = pSensitive[n]
--    tmpImg = pImg.duplicate()
--    tmpImg.copyPixels(pDoImg, pDoImg.rect.offset(sec[1]+1, 4), pDoImg.rect, [#ink:36, #bgColor:rgb("#FF00FF")] )
--    
--    buttonImg = pButtonList[n][1]
--    tmpImg.copyPixels(buttonImg, buttonImg.rect.offset(sec[1]+2,5), buttonImg.rect, [#ink:36, #bgColor:rgb("#FF00FF")])
--    
--    pS.member.image = tmpImg
--  end if
--  pDoButtonPos = n
--end

----------------------------------------
-- 
----------------------------------------
--on XmouseUp me
--  buttonPos = pDoButtonPos
--  if buttonPos then
--    tAction = pButtonList[buttonPos][2]
--    me.reset() -- ???
--    if listP(tAction) then
--      --call (#handlerName, script, {args...}
--      call(tAction[1],tAction[2], me, buttonPos)
--    else
--      sendAllSprites(tAction, me, buttonPos)
--    end if
--    --me.reset() -- problem: schon auf anderem frame!
--  end if
--end

----------------------------------------
-- 
----------------------------------------
--on Xreset me
--  pS.member.image = pImg
--  --pS.member.regpoint=point(0,0)
--  --pS.loc = point(0,0)
--  pS.rect=rect(0,0,420,30)
--  
--  pRoButtonPos = 0
--  pDoButtonPos = 0 -- ???
--end

----------------------------------------
-- 
----------------------------------------
--on XfindButton (me, p)
--  x = p[1]
--  y = p[2]  
--  if (y>2 AND y<26) then 
--    cnt = pSensitive.count
--    repeat with i = 1 to cnt
--      sec = pSensitive[i]
--      if voidP(sec) then next repeat
--      if x>=sec[1] AND x<=sec[2] then return i
--      if sec[1]>x then exit repeat
--    end repeat
--  end if
--  return 0
--end

----------------------------------------
-- TOOLTIP
----------------------------------------

----------------------------------------
-- 
----------------------------------------
--on mouseWithin me
--  m = the mouseLoc 
--  if m <> pMouseLoc then
--    pMouseLoc = m
--    pMouseTicks = the ticks
--  end if
--  
--  if the ticks-pMouseTicks>=pTicks then 
--    sendAllSprites(#showToolTip, pTooltipText) --, point(sprite(me.spriteNum).right+10, the mouseV) )
--  else
--    sendAllSprites(#hideToolTip)
--  end if
--end

----------------------------------------
-- 
----------------------------------------
--on setTooltipText me, tooltipText
--  pTooltipText = tooltipText
--end

----------------------------------------
-- 
----------------------------------------
--on getPropertyDescriptionList me
--  pl = [:]
--  pl[#pTicks] = [#comment:"Ticks to wait", #format:#integer, #default:30]
--  pl[#pTooltipText] = [#comment:"Tooltip-Text", #format:#string, #default:""]
--  return pl
--end

--